diff --git a/gdb/testsuite/gdb.dwarf2/dw2-gas-workaround.exp b/gdb/testsuite/gdb.dwarf2/dw2-gas-workaround.exp
index 1880f4cb7fb..5d6e13a9ae0 100644
--- a/gdb/testsuite/gdb.dwarf2/dw2-gas-workaround.exp
+++ b/gdb/testsuite/gdb.dwarf2/dw2-gas-workaround.exp
@@ -70,7 +70,7 @@ Dwarf::assemble $asm_file {
 	    line [line_for bar_label]
 	    DW_LNS_copy
 
-	    DW_LNE_set_address bar_label_2
+	    DW_LNE_set_address $bar_end
 	    DW_LNE_end_sequence
 	}
     }
diff --git a/gdb/testsuite/gdb.dwarf2/dw2-inline-header-1.exp b/gdb/testsuite/gdb.dwarf2/dw2-inline-header-1.exp
index 6d12e968f41..1f30c5c3316 100644
--- a/gdb/testsuite/gdb.dwarf2/dw2-inline-header-1.exp
+++ b/gdb/testsuite/gdb.dwarf2/dw2-inline-header-1.exp
@@ -146,7 +146,7 @@ proc do_test { start_label func_name tag } {
 		DW_LNS_advance_line 1
 		DW_LNS_copy
 
-		DW_LNE_set_address line_label_7
+		DW_LNE_set_address "$main_start + $main_len"
 		DW_LNE_end_sequence
 	    }
 	}
diff --git a/gdb/testsuite/gdb.dwarf2/dw2-inline-header-2.exp b/gdb/testsuite/gdb.dwarf2/dw2-inline-header-2.exp
index 6a5f7d6dd76..68f1fc83859 100644
--- a/gdb/testsuite/gdb.dwarf2/dw2-inline-header-2.exp
+++ b/gdb/testsuite/gdb.dwarf2/dw2-inline-header-2.exp
@@ -134,7 +134,7 @@ Dwarf::assemble $asm_file {
 	    DW_LNS_advance_line 1
 	    DW_LNS_copy
 
-	    DW_LNE_set_address line_label_7
+	    DW_LNE_set_address "$main_start + $main_len"
 	    DW_LNE_end_sequence
 	}
     }
diff --git a/gdb/testsuite/gdb.dwarf2/dw2-inline-header-3.exp b/gdb/testsuite/gdb.dwarf2/dw2-inline-header-3.exp
index b3db154db25..1b8d136e70e 100644
--- a/gdb/testsuite/gdb.dwarf2/dw2-inline-header-3.exp
+++ b/gdb/testsuite/gdb.dwarf2/dw2-inline-header-3.exp
@@ -123,7 +123,7 @@ Dwarf::assemble $asm_file {
 	    DW_LNS_negate_stmt
 	    DW_LNS_copy
 
-	    DW_LNE_set_address line_label_7
+	    DW_LNE_set_address "$main_start + $main_len"
 	    DW_LNE_end_sequence
 	}
     }
diff --git a/gdb/testsuite/gdb.dwarf2/dw2-line-number-zero.exp b/gdb/testsuite/gdb.dwarf2/dw2-line-number-zero.exp
index 603a616930a..c510de42037 100644
--- a/gdb/testsuite/gdb.dwarf2/dw2-line-number-zero.exp
+++ b/gdb/testsuite/gdb.dwarf2/dw2-line-number-zero.exp
@@ -27,6 +27,9 @@ Dwarf::assemble $asm_file {
     declare_labels Llines
     global srcdir subdir srcfile
 
+    get_func_info bar1
+    get_func_info bar2
+
     cu {} {
 	compile_unit {
 	    {language @DW_LANG_C}
@@ -69,7 +72,7 @@ Dwarf::assemble $asm_file {
 	    line 33
 	    DW_LNS_copy
 
-	    DW_LNE_set_address bar1_label_5
+	    DW_LNE_set_address $bar1_end
 	    DW_LNE_end_sequence
 
 
@@ -91,7 +94,7 @@ Dwarf::assemble $asm_file {
 	    line 47
 	    DW_LNS_copy
 
-	    DW_LNE_set_address bar2_label_5
+	    DW_LNE_set_address $bar2_end
 	    DW_LNE_end_sequence
 	}
     }
diff --git a/gdb/testsuite/gdb.dwarf2/dw2-lines.exp b/gdb/testsuite/gdb.dwarf2/dw2-lines.exp
index 5fd6ae04d38..85d5e9c8afb 100644
--- a/gdb/testsuite/gdb.dwarf2/dw2-lines.exp
+++ b/gdb/testsuite/gdb.dwarf2/dw2-lines.exp
@@ -104,7 +104,7 @@ proc test_1 { _cv _cdw64 _lv _ldw64 {_string_form ""}} {
 		line [line_for bar_label_4]
 		DW_LNS_copy
 
-		DW_LNE_set_address bar_label_5
+		DW_LNE_set_address "$main_start + $main_len"
 		DW_LNE_end_sequence
 	    }
 	}
diff --git a/gdb/testsuite/gdb.dwarf2/dw2-vendor-extended-opcode.exp b/gdb/testsuite/gdb.dwarf2/dw2-vendor-extended-opcode.exp
index 671e3e634ac..5a0705fc613 100644
--- a/gdb/testsuite/gdb.dwarf2/dw2-vendor-extended-opcode.exp
+++ b/gdb/testsuite/gdb.dwarf2/dw2-vendor-extended-opcode.exp
@@ -30,6 +30,8 @@ Dwarf::assemble $asm_file {
     set DW_LNE_lo_usr 0x80
     set DW_LNE_hi_usr 0xff
 
+    get_func_info main
+
     cu {} {
 	compile_unit {
 	    {language @DW_LANG_C}
@@ -54,7 +56,7 @@ Dwarf::assemble $asm_file {
 	    DW_LNE_user 2 $DW_LNE_hi_usr
 	    DW_LNS_copy
 
-	    DW_LNE_set_address main_label_2
+	    DW_LNE_set_address $main_end
 	    DW_LNE_end_sequence
 	}
     }
diff --git a/gdb/testsuite/gdb.dwarf2/imported-unit-bp.exp.tcl b/gdb/testsuite/gdb.dwarf2/imported-unit-bp.exp.tcl
index 968378620a0..5817b2b0f53 100644
--- a/gdb/testsuite/gdb.dwarf2/imported-unit-bp.exp.tcl
+++ b/gdb/testsuite/gdb.dwarf2/imported-unit-bp.exp.tcl
@@ -110,7 +110,7 @@ Dwarf::assemble $asm_file {
 	    DW_LNS_negate_stmt
 	    DW_LNS_copy
 
-	    DW_LNE_set_address line_label_7
+	    DW_LNE_set_address "$func_start + $func_len"
 	    DW_LNE_end_sequence
 	}
     }
diff --git a/gdb/testsuite/gdb.reverse/map-to-same-line.c b/gdb/testsuite/gdb.reverse/map-to-same-line.c
index 45e7ffb0f06..7185955f40a 100644
--- a/gdb/testsuite/gdb.reverse/map-to-same-line.c
+++ b/gdb/testsuite/gdb.reverse/map-to-same-line.c
@@ -53,6 +53,5 @@ main (void)
   asm ("main_return: .globl main_return");
   k = j; f3 = f2; str_3 = str_2;    /* TAG: main return */
 
-  asm ("end_of_sequence: .globl end_of_sequence");
   return 0; /* TAG: main return */
 }
diff --git a/gdb/testsuite/gdb.reverse/map-to-same-line.exp b/gdb/testsuite/gdb.reverse/map-to-same-line.exp
index b556e7cb676..067fe012702 100644
--- a/gdb/testsuite/gdb.reverse/map-to-same-line.exp
+++ b/gdb/testsuite/gdb.reverse/map-to-same-line.exp
@@ -100,7 +100,8 @@ Dwarf::assemble $asm_file {
 	    DW_LNE_set_address main_return
 	    line [gdb_get_line_number "TAG: main return"]
 	    DW_LNS_copy
-	    DW_LNE_set_address end_of_sequence
+
+	    DW_LNE_set_address $main_end
 	    DW_LNE_end_sequence
 	}
     }